package asp.netobjects.nfx.ui;

import com.sun.java.swing.AbstractListModel;
import com.sun.java.swing.DefaultListModel;

public class OrderedListModel extends DefaultListModel {
   private boolean _ordered = false;

   public void setOrdered(boolean ordered) {
      if (!this.isOrdered()) {
         this.order();
      }

      this._ordered = ordered;
   }

   public boolean isOrdered() {
      return this._ordered;
   }

   protected void order() {
      if (((DefaultListModel)this).getSize() > 0) {
         this.qsort(0, ((DefaultListModel)this).getSize() - 1);
      }

   }

   private void qsort(int start, int end) {
      int i;
      do {
         i = start;
         int j = end;
         Object miditem = ((DefaultListModel)this).getElementAt(start + end >> 1);

         do {
            while(this.compare(((DefaultListModel)this).getElementAt(i), miditem) < 0) {
               ++i;
            }

            while(this.compare(((DefaultListModel)this).getElementAt(j), miditem) > 0) {
               --j;
            }

            if (i <= j) {
               Object t = ((DefaultListModel)this).getElementAt(i);
               super.setElementAt(((DefaultListModel)this).getElementAt(j), i);
               super.setElementAt(t, j);
               ++i;
               --j;
            }
         } while(i <= j);

         if (start < j) {
            this.qsort(start, j);
         }

         start = i;
      } while(i < end);

   }

   protected int compare(Object o1, Object o2) {
      return o1.toString().compareTo(o2.toString());
   }

   public Object[] find(Object target) {
      boolean found = false;
      int start = 0;
      int end = ((DefaultListModel)this).getSize() - 1;

      while(start <= end) {
         int i = start + end >> 1;
         int c = this.compare(((DefaultListModel)this).getElementAt(i), target);
         if (c < 0) {
            start = i + 1;
         } else {
            end = i - 1;
            if (c == 0) {
               found = true;
            }
         }
      }

      return new Object[]{new Boolean(found), new Integer(start)};
   }

   public void insertElementAt(Object obj, int index) {
      if (!this.isOrdered()) {
         super.insertElementAt(obj, index);
      }

      ((AbstractListModel)this).fireContentsChanged(this, index - 1, index);
   }

   public void setElementAt(Object obj, int index) {
      if (!this.isOrdered()) {
         super.setElementAt(obj, index);
      }

      ((AbstractListModel)this).fireContentsChanged(this, index - 1, index);
   }

   public void removeElementAt(int index) {
      super.removeElementAt(index);
      ((AbstractListModel)this).fireContentsChanged(this, index - 1, index);
   }

   public void addElement(Object obj) {
      if (!this.isOrdered()) {
         super.addElement(obj);
      } else {
         Object[] result = this.find(obj);
         int index = (Integer)result[1];
         if (index >= ((DefaultListModel)this).getSize()) {
            super.addElement(obj);
         } else {
            super.insertElementAt(obj, index);
         }
      }

      int n = ((DefaultListModel)this).getSize();
      ((AbstractListModel)this).fireContentsChanged(this, n - 1, n);
   }
}
